
"""Base classes and utility code used by the autogenerated protocol code.

This module is normally not used directly.
"""

from __future__ import absolute_import


def parseList(buf, count, cls):
    result = []
    offset = 0
    for i in xrange(count):
        entry = cls(buffer(buf, offset))
        offset += entry._offset
        result.append(entry)
    return result, offset


def popcount(mask):
    # Ripped from xcb_util.c (libxcb).
    y = (mask >> 1) & 033333333333
    y = mask - y - ((y >> 1) & 033333333333)
    return ((y + (y >> 3)) & 030707070707) % 077


class Event(object):
    """Base class for events. This is purely for documentation."""

class Struct(object):
    """Base class for structs. This is purely for documentation."""

class Union(object):
    """Base class for unions. This is purely for documentation."""

class Enum(object):
    """Base class for enums. This is purely for documentation."""

class Reply(object):
    """Base class for replies. This is purely for documentation."""


class Core(object):

    """Base class for the core protocol."""

    def __init__(self, connection):
        self.connection = connection


class Extension(object):

    """Base class for extensions."""

    def __init__(self, connection, major_opcode):
        self.connection = connection
        self.major_opcode = major_opcode
