
from twisted.trial import unittest

from tx11 import core


class DisplayParserTest(unittest.TestCase):

    # Not very systematical but this still catches most corner cases.

    def test_localNoScreen(self):
        self.assertEqual(('', None, 0, -1), core._parseDisplay(':0', -1))

    def test_localScreen(self):
        self.assertEqual(('', None, 3, 1), core._parseDisplay(':3.1', -1))

    def test_bogus(self):
        self.assertRaises(ValueError, core._parseDisplay, 'bogus', -1)

    def test_empty(self):
        self.assertRaises(ValueError, core._parseDisplay, '', -1)

    def test_remoteScreen(self):
        self.assertEqual(('foobar', None, 3, 1),
                         core._parseDisplay('foobar:3.1', -1))

    def test_remoteNoScreen(self):
        self.assertEqual(('foobar', None, 3, -1),
                         core._parseDisplay('foobar:3', -1))

    def test_justInt(self):
        self.assertRaises(ValueError, core._parseDisplay, '1')

    def test_justColon(self):
        self.assertRaises(ValueError, core._parseDisplay, ':')

    def test_bogusDisplay(self):
        self.assertRaises(ValueError, core._parseDisplay, ':kittens')

    def test_bogusScreen(self):
        self.assertRaises(ValueError, core._parseDisplay, ':0.kittens')

    def test_emptyScreen(self):
        self.assertRaises(ValueError, core._parseDisplay, ':0.')
